# coding: utf-8

"""
    ThorNode Query API

    ThorNode Query API  # noqa: E501

    OpenAPI spec version: 1.0.0-oas3
    Contact: zheye@umich.edu
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ThorchainLastblock(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'chain': 'str',
        'lastobservedin': 'int',
        'lastsignedout': 'int',
        'thorchain': 'int'
    }

    attribute_map = {
        'chain': 'chain',
        'lastobservedin': 'lastobservedin',
        'lastsignedout': 'lastsignedout',
        'thorchain': 'thorchain'
    }

    def __init__(self, chain=None, lastobservedin=None, lastsignedout=None, thorchain=None):  # noqa: E501
        """ThorchainLastblock - a model defined in Swagger"""  # noqa: E501
        self._chain = None
        self._lastobservedin = None
        self._lastsignedout = None
        self._thorchain = None
        self.discriminator = None
        if chain is not None:
            self.chain = chain
        if lastobservedin is not None:
            self.lastobservedin = lastobservedin
        if lastsignedout is not None:
            self.lastsignedout = lastsignedout
        if thorchain is not None:
            self.thorchain = thorchain

    @property
    def chain(self):
        """Gets the chain of this ThorchainLastblock.  # noqa: E501


        :return: The chain of this ThorchainLastblock.  # noqa: E501
        :rtype: str
        """
        return self._chain

    @chain.setter
    def chain(self, chain):
        """Sets the chain of this ThorchainLastblock.


        :param chain: The chain of this ThorchainLastblock.  # noqa: E501
        :type: str
        """

        self._chain = chain

    @property
    def lastobservedin(self):
        """Gets the lastobservedin of this ThorchainLastblock.  # noqa: E501


        :return: The lastobservedin of this ThorchainLastblock.  # noqa: E501
        :rtype: int
        """
        return self._lastobservedin

    @lastobservedin.setter
    def lastobservedin(self, lastobservedin):
        """Sets the lastobservedin of this ThorchainLastblock.


        :param lastobservedin: The lastobservedin of this ThorchainLastblock.  # noqa: E501
        :type: int
        """

        self._lastobservedin = lastobservedin

    @property
    def lastsignedout(self):
        """Gets the lastsignedout of this ThorchainLastblock.  # noqa: E501


        :return: The lastsignedout of this ThorchainLastblock.  # noqa: E501
        :rtype: int
        """
        return self._lastsignedout

    @lastsignedout.setter
    def lastsignedout(self, lastsignedout):
        """Sets the lastsignedout of this ThorchainLastblock.


        :param lastsignedout: The lastsignedout of this ThorchainLastblock.  # noqa: E501
        :type: int
        """

        self._lastsignedout = lastsignedout

    @property
    def thorchain(self):
        """Gets the thorchain of this ThorchainLastblock.  # noqa: E501


        :return: The thorchain of this ThorchainLastblock.  # noqa: E501
        :rtype: int
        """
        return self._thorchain

    @thorchain.setter
    def thorchain(self, thorchain):
        """Sets the thorchain of this ThorchainLastblock.


        :param thorchain: The thorchain of this ThorchainLastblock.  # noqa: E501
        :type: int
        """

        self._thorchain = thorchain

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ThorchainLastblock, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ThorchainLastblock):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
